## deepin-deb-installer 1.2.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

project(deepin-deb-installer)

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")

    # generate qm files
    execute_process(COMMAND bash "translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
else ()
    set(CMAKE_CXX_COMPILER "clang++")
endif ()

configure_file(environments.h.in environments.h @ONLY)

# Sources files
file(GLOB SRCS "*.h" "*.cpp" "widgets/*.h" "widgets/*.cpp")

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(QApt REQUIRED)
find_package(DtkWidget REQUIRED)

# Tell CMake to create the executable
add_executable(deepin-deb-installer ${SRCS} resources/resources.qrc)
target_include_directories(deepin-deb-installer PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})
target_link_libraries(deepin-deb-installer
    QApt
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

# Install qm files
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES}
        DESTINATION share/deepin-deb-installer/translations)

# install manual files
install(DIRECTORY dmanual/
        DESTINATION share/dman/deepin-deb-installer)

# Install icons
foreach (ICON_SIZE 16 24 32 48 64 96 128 256)
    install(FILES resources/images/deepin-deb-installer-${ICON_SIZE}px.svg
            RENAME deepin-deb-installer.svg
            DESTINATION share/icons/hicolor/${ICON_SIZE}x${ICON_SIZE}/apps)
endforeach ()

install(TARGETS deepin-deb-installer DESTINATION bin)
install(FILES deepin-deb-installer.desktop DESTINATION share/applications)
install(FILES deepin-deb-installer.applications DESTINATION share/application-registry)

=== debian/changelog ===
deepin-deb-installer (1.2.4-1) unstable; urgency=medium

  * Initial release (Closes: #871975)

 -- Yangfl <mmyangfl@gmail.com>  Thu, 15 Mar 2018 16:16:47 +0800

=== debian/control ===
Source: deepin-deb-installer
Section: utils
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
Build-Depends: debhelper (>= 11~), cmake, pkg-config, libqt5widgets5, libqt5concurrent5, libqapt-dev, libdtkwidget-dev, qttools5-dev-tools
Standards-Version: 4.1.3
Homepage: https://github.com/linuxdeepin/deepin-deb-installer
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer

Package: deepin-deb-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin Package Manager
 Deepin Package Manager is a management tool for deb package, and is developed
 for users to easily install customized applications that are not categorized
 in Deepin Store. With an easy-to-use interface as well as functions like batch
 installation, version detection and auto-completion of dependencies, you can
 quickly get the software installed on deepin once you get the right deb
 package.
 .
 This package is part of DDE (Deepin Desktop Environment).

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT = 5

include /usr/share/dpkg/pkg-info.mk


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DVERSION=$(DEB_VERSION_UPSTREAM)

override_dh_install:
	dh_install
	# tmp remove dman
	rm -r debian/deepin-deb-installer/usr/share/dman/

## deepin-deb-installer 1.2.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -55,10 +55,6 @@
 install(FILES ${QM_FILES}
         DESTINATION share/deepin-deb-installer/translations)
 
-# install manual files
-install(DIRECTORY dmanual/
-        DESTINATION share/dman/deepin-deb-installer)
-
 # Install icons
 foreach (ICON_SIZE 16 24 32 48 64 96 128 256)
     install(FILES resources/images/deepin-deb-installer-${ICON_SIZE}px.svg

=== debian/changelog ===
deepin-deb-installer (1.2.5-1) unstable; urgency=medium

  * New upstream version 1.2.5
  * Bump Standards-Version to 4.1.5 (no changes needed).
  * d/control: Add new uploader Yanhao Mo <yanhaocs@gmail.com>.
  * d/rules: Drop debian/deepin-deb-installer/usr/share/dman/ relevant part
    because the upstream doesn't produce that any more.

 -- Yanhao Mo <yanhaocs@gmail.com>  Sun, 22 Jul 2018 10:14:53 +0800

deepin-deb-installer (1.2.4-2) unstable; urgency=medium

  * Team upload.
  * Use team+pkg-deepin@tracker.debian.org in maintainer field.
  * d/rules: Use "dh_missing --fail-missing".
  * Apply "wrap-and-sort -abst".
  * Bump Standards-Version to 4.1.4 (no changes needed).

 -- Boyuan Yang <073plan@gmail.com>  Fri, 20 Apr 2018 18:30:59 +0800

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,26 @@
 Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
-Build-Depends: debhelper (>= 11~), cmake, pkg-config, libqt5widgets5, libqt5concurrent5, libqapt-dev, libdtkwidget-dev, qttools5-dev-tools
-Standards-Version: 4.1.3
+ Yanhao Mo <yanhaocs@gmail.com>,
+Build-Depends:
+ cmake,
+ debhelper (>= 11~),
+ libdtkwidget-dev,
+ libqapt-dev,
+ libqt5concurrent5,
+ libqt5widgets5,
+ pkg-config,
+ qttools5-dev-tools,
+Standards-Version: 4.1.5
 Homepage: https://github.com/linuxdeepin/deepin-deb-installer
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer
 
 Package: deepin-deb-installer
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Deepin Package Manager
  Deepin Package Manager is a management tool for deb package, and is developed
  for users to easily install customized applications that are not categorized

## deepin-deb-installer 1.2.9

=== debian/changelog ===
deepin-deb-installer (1.2.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.2.9.
  * debian/control:
    + Bump Standards-Version to 4.2.1.
    + Build-depend on debhelper-compat (= 11) to replace old
      debian/compat file.
    + R³: Use Rules-Requires-Root: no.
    + Tighten up versioned build-dependency to libdtkwidget-dev to
      (>= 2.0.9.10~) to fix FTBFS.

 -- Boyuan Yang <byang@debian.org>  Mon, 10 Dec 2018 10:43:32 -0500

=== debian/control ===
--- 
+++ 
@@ -7,14 +7,15 @@
  Yanhao Mo <yanhaocs@gmail.com>,
 Build-Depends:
  cmake,
- debhelper (>= 11~),
- libdtkwidget-dev,
+ debhelper-compat (= 11),
+ libdtkwidget-dev (>= 2.0.9.10~),
  libqapt-dev,
  libqt5concurrent5,
  libqt5widgets5,
  pkg-config,
  qttools5-dev-tools,
-Standards-Version: 4.1.5
+Rules-Requires-Root: no
+Standards-Version: 4.2.1
 Homepage: https://github.com/linuxdeepin/deepin-deb-installer
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer

## deepin-deb-installer 1.3.0

=== debian/changelog ===
deepin-deb-installer (1.3.0-1) unstable; urgency=medium

  * New upstream version 1.3.0
  * Standards-Version: Bump to 4.3.0 (no changes needed).

 -- Yanhao Mo <yanhaocs@gmail.com>  Mon, 25 Feb 2019 17:41:31 +0800

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  pkg-config,
  qttools5-dev-tools,
 Rules-Requires-Root: no
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/linuxdeepin/deepin-deb-installer
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT := 5

include /usr/share/dpkg/pkg-info.mk


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DVERSION=$(DEB_VERSION_UPSTREAM)

override_dh_missing:
	dh_missing --fail-missing

## deepin-deb-installer 5.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,9 @@
 
     # generate qm files
     execute_process(COMMAND bash "translate_generation.sh"
+                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
+
+    execute_process(COMMAND bash "translate_ts2desktop.sh"
                     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 else ()
     set(CMAKE_CXX_COMPILER "clang++")

=== debian/changelog ===
deepin-deb-installer (5.0.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:12:25 +0100

deepin-deb-installer (5.0.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release 5.0.0.
  * debian/control: Bump Standards-Version to 4.4.0.
  * debian/control: Bump debhelper compat to v12.

 -- Boyuan Yang <byang@debian.org>  Tue, 24 Sep 2019 16:45:48 -0400

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Yanhao Mo <yanhaocs@gmail.com>,
 Build-Depends:
  cmake,
- debhelper-compat (= 11),
+ debhelper-compat (= 12),
  libdtkwidget-dev (>= 2.0.9.10~),
  libqapt-dev,
  libqt5concurrent5,
@@ -15,7 +15,7 @@
  pkg-config,
  qttools5-dev-tools,
 Rules-Requires-Root: no
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/linuxdeepin/deepin-deb-installer
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 export QT_SELECT := 5
 
-include /usr/share/dpkg/pkg-info.mk
+include /usr/share/dpkg/default.mk
 
 
 %:

## deepin-deb-installer 5.6.0.19

=== debian/changelog ===
deepin-deb-installer (5.6.0.19-1) unstable; urgency=medium

  [ Clay Stan ]
  * New upstream version 5.6.0.19.
  * debian/control:
    + Add Clay Stan to Uploaders list.
    + Updated Build dependencies.
    + Bump debhelper compat to v13.

  [ Arun Kumar Pariyar ]
  * debian/control:
    + Set build dependency libdtkwidget-dev to (>=5.2~).
    + Bump Standards-Version to 4.5.1.
    + Add Arun Kumar Pariyar to Uploaders list.
  * debian/copyright:
    + Add Upstream-Contact.
    + Update copyright license information.
  * Add deepin-deb-installer-dependsInstall to lintian-overrides.
  * debian/rules: Update to ensure proper build.
  * debian/patches:
    + Add patch to fix keywords missing in desktop file.
    + Add patch to fix build with Qt 5.15+.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Sun, 06 Dec 2020 18:19:29 +0545

=== debian/control ===
--- 
+++ 
@@ -5,17 +5,20 @@
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
  Yanhao Mo <yanhaocs@gmail.com>,
+ Clay Stan <claystan97@gmail.com>,
+ Arun Kumar Pariyar <openarungeek@gmail.com>,
 Build-Depends:
- cmake,
- debhelper-compat (= 12),
- libdtkwidget-dev (>= 2.0.9.10~),
+ debhelper-compat (= 13),
+ libdtkwidget-dev (>=5.2~),
  libqapt-dev,
  libqt5concurrent5,
  libqt5widgets5,
  pkg-config,
+ qt5-qmake,
+ qtbase5-dev,
  qttools5-dev-tools,
 Rules-Requires-Root: no
-Standards-Version: 4.4.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/linuxdeepin/deepin-deb-installer
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer
@@ -23,6 +26,7 @@
 Package: deepin-deb-installer
 Architecture: any
 Depends:
+ libqapt3-runtime,
  ${misc:Depends},
  ${shlibs:Depends},
 Description: Deepin Package Manager

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export QT_SELECT := 5

include /usr/share/dpkg/default.mk


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- DAPP_VERSION=$(DEB_VERSION_UPSTREAM) DEFINES+="VERSION=$(DEB_VERSION_UPSTREAM)" LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_install:
	dh_auto_install --max-parallel=1

override_dh_missing:
	dh_missing --fail-missing

execute_after_auto_clean:
	find translations -type f -name *.qm -delete

## deepin-deb-installer 5.7.0.39

=== CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     cuizhen <cuizhen@deepin.io>
#
# Maintainer: cuizhen <cuizhen@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.13)

if (NOT DEFINED VERSION)
    set(VERSION 5.3.9)
endif ()

project(deepin_deb_installer)
option(DMAN_RELEAE OFF "Install dman resources to system or not")

find_package(Qt5LinguistTools REQUIRED)
set(POLICY_FILE com.deepin.pkexec.aptInstallDepend.policy)
add_subdirectory(src/AptInstallDepend)
add_subdirectory(src/deb_installer)
add_subdirectory(tests)
add_subdirectory(src/deepin-deb-installer-lib)
add_subdirectory(translations)
#add_subdirectory(tests/FuzzyTest)

=== tests/CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     cuizhen <cuizhen@deepin.io>
#
# Maintainer: cuizhen <cuizhen@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.7)
if (NOT DEFINED VERSION)
    message(WARNING "Not defined version ,about dialog version set 5.3.9")
    set(VERSION 5.3.9)
endif ()

find_package(GTest REQUIRED)
include_directories(${GTEST_INCLUDE_DIRS})
#common resource names
set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/assets")
set(APP_BIN_NAME_TEST "deepin-deb-installer-test")
set(APP_TRANS_SCRIPT "${APP_RES_DIR}/translate_generation.sh")
set(APP_DESKTOP "${APP_RES_DIR}/deepin-deb-installer.desktop")
set(APP_QRC "${APP_RES_DIR}/resources.qrc")

project(${APP_BIN_NAME_TEST})


ADD_COMPILE_OPTIONS(-fno-access-control)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")
#set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
#set(CMAKE_C_FLAGS "-g -fprofile-arcs -ftest-coverage")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")
else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage")

#Generate the qm file
execute_process(COMMAND bash ${APP_TRANS_SCRIPT}
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/")

configure_file(${APP_RES_DIR}/environments.h.in environments.h @ONLY)

add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)
# Find the library

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
find_package(Qt5DBus REQUIRED)
set(LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)

macro(SUBDIRLIST result curdir)
    file(GLOB children RELATIVE ${curdir} ${curdir}/*)
    set(dirlist "")
    foreach(child ${children})
        if(IS_DIRECTORY ${curdir}/${child})
            LIST(APPEND dirlist ${child})
        endif()
    endforeach()
    set(${result} ${dirlist})
endmacro()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src/deb_installer/)

SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR}/../src/deb_installer/)

#Include all app own subdirectorys
foreach(subdir ${all_src})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}${subdir})
endforeach()

file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/singleInstallerApplication.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/model/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/utils/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/view/pages/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/view/widgets/*.cpp
    )
FILE(GLOB allTestSource
  src/*.cpp
  src/manager/*.cpp
  src/model/*.cpp
  src/utils/*.cpp
  src/view/pages/*.cpp
  src/view/widgets/*.cpp
)
include_directories(src)
include_directories( ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/)
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

# Tell CMake to create the executable
add_executable(${APP_BIN_NAME_TEST} ${APP_SRCS} ${APP_QRC} ${TEST_ACCESSIBLE_HEADERS_FILES}  ${allTestSource} )

target_include_directories(${APP_BIN_NAME_TEST}
    PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})


target_link_libraries(${APP_BIN_NAME_TEST}
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${GTEST_MAIN_LIBRARIES}
    pthread
)

add_custom_target(test
    COMMAND echo " =================== TEST BEGIN ==================== "
    COMMAND ${CMAKE_BINARY_DIR}/tests/${APP_BIN_NAME_TEST}
    COMMAND echo " =================== TEST END ==================== "
)

=== src/deb_installer/CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     cuizhen <cuizhen@deepin.io>
#
# Maintainer: cuizhen <cuizhen@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.7)
if (NOT DEFINED VERSION)
    message(WARNING "Not defined version ,about dialog version set 5.3.9")
    set(VERSION 5.3.9)
endif ()

#common resource names
set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/assets")
set(APP_BIN_NAME "deepin-deb-installer")
set(APP_TRANS_SCRIPT "${APP_RES_DIR}/translate_generation.sh")
set(APP_DESKTOP "${APP_RES_DIR}/deepin-deb-installer.desktop")
set(APP_QRC "${APP_RES_DIR}/resources.qrc")

project(${APP_BIN_NAME})

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")

  # 添加宏定义只在debug模式下输出性能打点日志
  add_definitions("-DDEBUG")

else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

#Generate the qm file
execute_process(COMMAND bash ${APP_TRANS_SCRIPT}
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/")

configure_file(${APP_RES_DIR}/environments.h.in environments.h @ONLY)

add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)
# Find the library

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
find_package(Qt5DBus REQUIRED)
set(LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)

macro(SUBDIRLIST result curdir)
    file(GLOB children RELATIVE ${curdir} ${curdir}/*)
    set(dirlist "")
    foreach(child ${children})
        if(IS_DIRECTORY ${curdir}/${child})
            LIST(APPEND dirlist ${child})
        endif()
    endforeach()
    set(${result} ${dirlist})
endmacro()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR})

#Include all app own subdirectorys
foreach(subdir ${all_src})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}${subdir})
endforeach()

file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/model/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/utils/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/view/pages/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/view/widgets/*.cpp
    )

include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

# Tell CMake to create the executable
add_executable(${PROJECT_NAME} ${APP_SRCS} ${APP_QRC})

target_include_directories(${APP_BIN_NAME}
    PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})

target_link_libraries(${APP_BIN_NAME}
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)
set(CMAKE_INSTALL_PREFIX /usr)

# Install files
install(DIRECTORY ${APP_RES_DIR}/deepin-deb-installer DESTINATION /usr/share/deepin-manual/manual-assets/application/)
install(TARGETS deepin-deb-installer DESTINATION bin)
install(FILES ${APP_CONFIG} DESTINATION share/deepin-deb-installer)
install(FILES ${APP_DESKTOP} DESTINATION share/applications)

=== src/deepin-deb-installer-lib/CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     cuizhen <cuizhen@deepin.io>
#
# Maintainer: cuizhen <cuizhen@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.13)

if (NOT DEFINED VERSION)
    set(VERSION 5.3.9)
endif ()
set(APP_BIN_NAME "libdeepin-deb-installer")

project(deepin-deb-installer-lib)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

find_package(PkgConfig REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5DBus REQUIRED)

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    QApt
    Qt5::Concurrent
)

file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/installer/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/package/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/status/*.cpp
    )

file(GLOB_RECURSE APP_INCLUDE
    ${CMAKE_CURRENT_LIST_DIR}/deepin-deb-installer-lib_global.h
    ${CMAKE_CURRENT_LIST_DIR}/DeepinDebInstallerLib.h
    )

add_library( ${APP_BIN_NAME} SHARED ${APP_SRCS})

# Find the library
target_link_libraries(${APP_BIN_NAME}
    Qt5::Core
    Qt5::DBus
    QApt
    Qt5::Concurrent
)

set(CMAKE_INSTALL_PREFIX /usr)
# Install files

SET_TARGET_PROPERTIES(${APP_BIN_NAME} PROPERTIES VERSION 1.0.0 SOVERSION 1)

install(TARGETS ${APP_BIN_NAME} LIBRARY DESTINATION lib)

install(FILES ${APP_INCLUDE} DESTINATION  include/deepin-deb-installer)

execute_process(COMMAND "ldconfig")

=== translations/desktop/CMakeLists.txt ===
find_program(DESKTOP_TS_CONV deepin-desktop-ts-convert REQUIRED)

set(DESKTOP_FILE ${CMAKE_PROJECT_NAME}.desktop)

add_custom_target(APP_DESKTOP_FILE
    ALL
    COMMAND ${DESKTOP_TS_CONV} ts2desktop ${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE}.tmp
    COMMAND mv ${DESKTOP_FILE}.tmp ${DESKTOP_FILE}
)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE} DESTINATION share/applications)

=== debian/changelog ===
deepin-deb-installer (5.7.0.39-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 15 Mar 2021 09:42:33 +0800

deepin-deb-installer (5.3.9) unstable; urgency=medium

  * Initial Release.

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 11 Oct 2017 17:38:35 +0800

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT := 5
# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
include /usr/share/dpkg/default.mk

override_dh_auto_configure:
	dh_auto_configure -- \
    -DCMAKE_BUILD_TYPE=Release \
    -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
%:
	dh $@

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

## deepin-deb-installer 5.8.1

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -43,14 +43,29 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
-set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-need -fPIE")
 set(CMAKE_EXE_LINKER_FLAGS "-pie")
-#set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
-#set(CMAKE_C_FLAGS "-g -fprofile-arcs -ftest-coverage")
+
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
+set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
 
 if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
 endif ()
+
+set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
+
+if(CMAKE_SAFETYTEST STREQUAL "")
+    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
+endif()
+
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
+
+if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
+  #安全测试选项
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
+endif()
 
 #compile flags
 if (CMAKE_BUILD_TYPE MATCHES Debug)
@@ -59,6 +74,7 @@
 
   # Enable Qt builtin debug mode
   add_definitions("-DQT_MESSAGELOGCONTEXT")
+
 else()
   # -Wl, -O2 Enable linker optimizations
   # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
@@ -89,6 +105,7 @@
 find_package(DtkGui REQUIRED)
 find_package(DtkCore REQUIRED)
 find_package(Qt5DBus REQUIRED)
+find_package(Qt5Test REQUIRED)
 set(LINK_LIBS
     Qt5::Core
     Qt5::Widgets
@@ -112,9 +129,9 @@
     set(${result} ${dirlist})
 endmacro()
 
-include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src/deb_installer/)
+include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src/deb-installer)
 
-SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR}/../src/deb_installer/)
+SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR}/../src/deb-installer/)
 
 #Include all app own subdirectorys
 foreach(subdir ${all_src})
@@ -122,12 +139,12 @@
 endforeach()
 
 file(GLOB_RECURSE APP_SRCS
-    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/singleInstallerApplication.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/manager/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/model/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/utils/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/view/pages/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/view/widgets/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/singleInstallerApplication.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/manager/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/model/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/utils/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/pages/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/widgets/*.cpp
     )
 FILE(GLOB allTestSource
   src/*.cpp
@@ -138,7 +155,7 @@
   src/view/widgets/*.cpp
 )
 include_directories(src)
-include_directories( ${CMAKE_CURRENT_LIST_DIR}/../src/deb_installer/)
+include_directories( ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/)
 include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})
 
 # Tell CMake to create the executable
@@ -154,6 +171,7 @@
     Qt5::Gui
     Qt5::DBus
     QApt
+    Qt5::Test
     Qt5::Concurrent
     ${DtkWidget_LIBRARIES}
     ${DtkCore_LIBRARIES}

=== src/AptInstallDepend/CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     cuizhen <cuizhen@deepin.io>
#
# Maintainer: cuizhen <cuizhen@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
cmake_minimum_required(VERSION 3.13)

if (NOT DEFINED VERSION)
    set(VERSION 5.3.9)
endif ()

project(AptInstallDepend)
set (EXE_NAME deepin-deb-installer-dependsInstall)
set(LINK_LIBS
    Qt5::Core
)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

file(GLOB_RECURSE AUTH_CPP_FILES ${CMAKE_CURRENT_LIST_DIR}/*.cpp)
add_executable (${EXE_NAME}
    ${AUTH_CPP_FILES}
)

# Find the library
find_package(Qt5Core REQUIRED)
set(CMAKE_INSTALL_PREFIX /usr)
# Install files
install(TARGETS ${EXE_NAME} DESTINATION bin)
target_link_libraries(${EXE_NAME} ${LINK_LIBS} )

=== src/deb-installer/CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     cuizhen <cuizhen@deepin.io>
#
# Maintainer: cuizhen <cuizhen@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.7)
if (NOT DEFINED VERSION)
    message(WARNING "Not defined version ,about dialog version set 5.3.9")
    set(VERSION 5.3.9)
endif ()

#common resource names
set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/assets")
set(APP_BIN_NAME "deepin-deb-installer")
set(APP_TRANS_SCRIPT "${APP_RES_DIR}/translate_generation.sh")
set(APP_DESKTOP "${APP_RES_DIR}/deepin-deb-installer.desktop")
set(APP_QRC "${APP_RES_DIR}/resources.qrc")

project(${APP_BIN_NAME})

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")

  # 添加宏定义只在debug模式下输出性能打点日志
  add_definitions("-DDEBUG")

  if(CMAKE_SAFETYTEST)
  #安全测试选项
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fsanitize=undefined,address -O2")
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -g -fsanitize=undefined,address -O2")
    set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -g -fsanitize=undefined,address -O2")
    set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}  -g -fsanitize=undefined,address -O2")
   endif()

else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -O2 -Wl,-O1 -Wl,--gc-sections")

endif()

#Generate the qm file
execute_process(COMMAND bash ${APP_TRANS_SCRIPT}
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/")

configure_file(${APP_RES_DIR}/environments.h.in environments.h @ONLY)

add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)
# Find the library

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
find_package(Qt5DBus REQUIRED)
set(LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)

macro(SUBDIRLIST result curdir)
    file(GLOB children RELATIVE ${curdir} ${curdir}/*)
    set(dirlist "")
    foreach(child ${children})
        if(IS_DIRECTORY ${curdir}/${child})
            LIST(APPEND dirlist ${child})
        endif()
    endforeach()
    set(${result} ${dirlist})
endmacro()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR})

#Include all app own subdirectorys
foreach(subdir ${all_src})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}${subdir})
endforeach()

include_directories(${CMAKE_CURRENT_LIST_DIR}/utils)

file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/model/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/utils/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/view/pages/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/view/widgets/*.cpp

    )

include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

# Tell CMake to create the executable
add_executable(${PROJECT_NAME} ${APP_SRCS} ${APP_QRC})

target_include_directories(${APP_BIN_NAME}
    PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})

target_link_libraries(${APP_BIN_NAME}
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)
set(CMAKE_INSTALL_PREFIX /usr)

# Install files
install(DIRECTORY ${APP_RES_DIR}/deepin-deb-installer DESTINATION /usr/share/deepin-manual/manual-assets/application/)
install(TARGETS deepin-deb-installer RUNTIME DESTINATION bin)
install(FILES ${APP_CONFIG} DESTINATION share/deepin-deb-installer)
install(FILES ${APP_DESKTOP} DESTINATION share/applications)

=== src/deepin-deb-installer-dev/CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     cuizhen <cuizhen@deepin.io>
#
# Maintainer: cuizhen <cuizhen@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.13)

if (NOT DEFINED VERSION)
    set(VERSION 5.3.9)
endif ()
set(APP_BIN_NAME "libdeepin-deb-installer")

project(deepin-deb-installer-dev)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

find_package(PkgConfig REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5DBus REQUIRED)

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    QApt
    Qt5::Concurrent
)
include_directories(${CMAKE_CURRENT_LIST_DIR})
file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/installer/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/package/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/status/*.cpp
    )

file(GLOB_RECURSE APP_INCLUDE
    ${CMAKE_CURRENT_LIST_DIR}/deepin-deb-installer-lib_global.h
    ${CMAKE_CURRENT_LIST_DIR}/DeepinDebInstallerLib.h
    )

add_library( ${APP_BIN_NAME} SHARED ${APP_SRCS})

# Find the library
target_link_libraries(${APP_BIN_NAME}
    Qt5::Core
    Qt5::DBus
    QApt
    Qt5::Concurrent
)

set(CMAKE_INSTALL_PREFIX /usr)
# Install files

SET_TARGET_PROPERTIES(${APP_BIN_NAME} PROPERTIES VERSION 1.0.0 SOVERSION 1)

install(TARGETS ${APP_BIN_NAME} LIBRARY DESTINATION lib)

install(FILES ${APP_INCLUDE} DESTINATION  include/deepin-deb-installer)

execute_process(COMMAND "ldconfig")

=== debian/changelog ===
deepin-deb-installer (5.8.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release 5.8.1.
  * debian/rules: Force non-parallel build to fit low-memory buildd
    architectures like mipsel.
  * debian/patches: Refresh patches.
    + Add patch to fix missing unistd.h header in PackageStatus.cpp.
  * debian/control: Add new build-dependency deepin-gettext-tools.

 -- Boyuan Yang <byang@debian.org>  Wed, 10 Nov 2021 13:49:52 -0500

deepin-deb-installer (5.7.0.17-1) unstable; urgency=medium

  * Team upload.

  [ Clay Stan ]
  * New upstream version 5.7.0.17.

  [ Boyuan Yang ]
  * debian/control: Drop Yangfl from uploaders list as requested.
  * debian/control: Bump Standards-Version to 4.6.0.
  * debian/control: Update build-dependency list.
  * debian/patches: Disable patches for now, non-standard googletest
    is needed.

 -- Boyuan Yang <byang@debian.org>  Wed, 10 Nov 2021 00:01:55 -0500

=== debian/control ===
--- 
+++ 
@@ -3,22 +3,23 @@
 Priority: optional
 Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
 Uploaders:
- Yangfl <mmyangfl@gmail.com>,
  Yanhao Mo <yanhaocs@gmail.com>,
  Clay Stan <claystan97@gmail.com>,
  Arun Kumar Pariyar <openarungeek@gmail.com>,
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
- libdtkwidget-dev (>=5.2~),
+ deepin-gettext-tools,
+ libdtkwidget-dev (>= 5.5.17~),
  libqapt-dev,
  libqt5concurrent5,
  libqt5widgets5,
  pkg-config,
- qt5-qmake,
  qtbase5-dev,
+ qttools5-dev,
  qttools5-dev-tools,
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/linuxdeepin/deepin-deb-installer
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer

## deepin-deb-installer 5.8.11

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -46,8 +46,11 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-need -fPIE")
 set(CMAKE_EXE_LINKER_FLAGS "-pie")
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
-set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
+#安全测试加固编译参数
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
 
 if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")

=== src/deb-installer/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,12 @@
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
+
+#安全测试加固编译参数
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
 
 if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")

=== debian/changelog ===
deepin-deb-installer (5.8.11-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 20 Jan 2022 11:23:38 +0800

## deepin-deb-installer 5.8.19

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -109,6 +109,8 @@
 find_package(DtkCore REQUIRED)
 find_package(Qt5DBus REQUIRED)
 find_package(Qt5Test REQUIRED)
+
+
 set(LINK_LIBS
     Qt5::Core
     Qt5::Widgets
@@ -146,6 +148,7 @@
     ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/manager/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/model/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/utils/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/process/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/pages/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/widgets/*.cpp
     )

=== src/deb-installer/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,11 @@
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
+
+if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+endif()
 
 #安全测试加固编译参数
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
@@ -107,6 +112,7 @@
 find_package(DtkGui REQUIRED)
 find_package(DtkCore REQUIRED)
 find_package(Qt5DBus REQUIRED)
+
 set(LINK_LIBS
     Qt5::Core
     Qt5::Widgets
@@ -146,6 +152,7 @@
     ${CMAKE_CURRENT_LIST_DIR}/manager/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/model/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/utils/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/process/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/view/pages/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/view/widgets/*.cpp

=== debian/changelog ===
deepin-deb-installer (5.8.19-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 16 May 2022 10:21:54 +0800

=== debian/control ===
Source: deepin-deb-installer
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9), pkg-config, cmake, libqt5widgets5, libqt5concurrent5, libqapt-dev, libdtkwidget-dev, qtbase5-dev, qttools5-dev-tools, qttools5-dev, qtchooser, libgtest-dev,  deepin-gettext-tools
Standards-Version: 4.3.0
Homepage: https://www.deepin.com/

Package: deepin-deb-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqapt3-runtime, libqapt3
Description: Package Installer helps users install and remove local packages.
 Package Installer is an easy-to-use .deb package management tool 
 with a simple interface for users to quickly install customized applications
 not included in App Store supporting bulk installation, version identification
 and auto completion.
